const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const cost_centers = sequelize.define(
    'cost_centers',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

code: {
        type: DataTypes.TEXT,
      
      

      },

name: {
        type: DataTypes.TEXT,
      
      

      },

isActive: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  cost_centers.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity











    db.cost_centers.hasMany(db.departments, {
      as: 'departments_costCenter',
      foreignKey: {
          name: 'costCenterId',
      },
      constraints: false,
    });


















    db.cost_centers.hasMany(db.journal_lines, {
      as: 'journal_lines_costCenter',
      foreignKey: {
          name: 'costCenterId',
      },
      constraints: false,
    });



    db.cost_centers.hasMany(db.ap_invoices, {
      as: 'ap_invoices_costCenter',
      foreignKey: {
          name: 'costCenterId',
      },
      constraints: false,
    });
















//end loop






    db.cost_centers.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.cost_centers.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return cost_centers;
};


